/**
 * @file noachiand/container.h
 * @brief noachiand LXC container wrapper
 */

/*
 * Copyright 2014 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, version 3, as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef NOACHIAND_CONTAINER_H
#define NOACHIAND_CONTAINER_H 1

#include <memory>


namespace Noachiand
{

/**
 * An interface class for Containers.
 */
class Container
{
public:
  class Impl;
  using ImplPtr = std::shared_ptr<Impl>;
  using Ptr = std::unique_ptr<Container>;

public:
  Container(ImplPtr const& impl);
  ~Container();

private:
  ImplPtr impl_;
};

} // namespace Noachiand

#endif /* NOACHIAND_CONTAINER_H */
