/**
 * @file noachiand/containerfactory.h
 * @brief abstract container factory interface
 */

/*
 * Copyright 2014 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, version 3, as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef NOACHIAND_CONTAINERFACTORY_H
#define NOACHIAND_CONTAINERFACTORY_H 1

#include "noachiand/container.h"


namespace Noachiand
{

/**
 * An pure virtual abstract factory class for Containers.
 */
class ContainerFactory
{
public:
  virtual ~ContainerFactory() = 0;

  /** Creates a container. */
  virtual Container::Ptr
  create_container() = 0;
};

} // namespace Noachiand

#endif /* NOACHIAND_CONTAINERFACTORY_H */
