/**
 * @file noachiand/controller.cpp
 * @brief noachiand controller interface
 */

/*
 * Copyright 2014 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, version 3, as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "noachiand/controller.h"

namespace Noachiand
{

struct Controller::Impl
{
  Impl(Configuration*         configuration,
       TrustedSessionFactory* trusted_session_factory,
       ContainerFactory*      container_factory)
  : configuration_(configuration)
  , trusted_session_factory_(trusted_session_factory)
  , container_factory_(container_factory)
  { }

private:
  Configuration*         configuration_;
  TrustedSessionFactory* trusted_session_factory_;
  ContainerFactory*      container_factory_;
};


Controller::
Controller(Configuration*         configuration,
           TrustedSessionFactory* trusted_session_factory,
           ContainerFactory*      container_factory)
: impl_(new Impl(configuration, trusted_session_factory, container_factory))
{ }


Controller::
~Controller()
{ }


void Controller::
start_application(std::string const&              application_path,
                  std::vector<std::string> const& argv,
                  uint32_t*                       id)
{
  if (application_path == "throw")
    throw std::runtime_error("failure requested");
  *id = 43;
}

} // namespace Noachiand
