/**
 * @file noachiand/dbusservice.cpp
 * @brief noachiand D-Bus service
 */

/*
 * Copyright 2014 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, version 3, as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef NOACHIAND_DBUSSERVICE_H
#define NOACHIAND_DBUSSERVICE_H 1

#include <memory>


namespace Noachiand
{
class Configuration;
class Controller;

class DbusService
{
public:
  struct Impl;

public:
  DbusService(Configuration* configuration,
              Controller*    controller);
  ~DbusService();

private:
  std::unique_ptr<Impl> impl_;
};

} // namespace Noachiand

#endif /* NOACHIAND_DBUSSERVICE_H */
