/**
 * @file test/gtest_mock_container.cpp
 * @brief Unit tests of the mock container.
 * Makes sure the mock container works, otherwise tests thatuse it will not be
 * reliable.
 */

/*
 * Copyright 2014 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, version 3, as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "test/mockcontainerimpl.h"

#include <gtest/gtest.h>
#include "test/mockcontainerfactory.h"

TEST(MockContainer, construct)
{
  ::Test::MockContainerFactory factory;

  Noachiand::Container::ImplPtr mock_container_impl(new ::Test::MockContainerImpl);
  factory.set_mock_container_impl(mock_container_impl);
  Noachiand::Container::Ptr container = factory.create_container();
}
